package de.hs_mannheim.informatik.spreadsheet;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;


/**
 * Part of a simplified spreadsheet system for the PR1 programming lab at Hochschule Mannheim.
 *
 * @author  Oliver Hummel
 */
public class Axel {
	
	Spreadsheet spr;
	public static void main(String[] args) throws IOException {
		Scanner scanner = new Scanner(System.in);
		String directoryPath = "C:\\Users\\devra\\git\\Axel\\Axel\\resources\\";
		String filePath = "C:\\Users\\devra\\git\\Axel\\Axel\\resources\\example.csv";
		
		System.out.println("\nWilkommen zum coolsten Spreadsheet Programm der Welt!");
		System.out.println("Was möchten sie machen?");
		
		System.out.println("\n 1. Neues Dokument erstellen");
		System.out.println(" 2. Dokument öffnen");
		System.out.println(" 3. Programm schließen");
		System.out.print("-> ");
		String userInput = scanner.nextLine();
		
		switch(userInput) {
			case "1":
				neuesDokument(directoryPath);
				break;
				
			case "2":
				dokumentAuswaehlen(directoryPath,filePath);
				break;
				
			case "3":
				break;
		}
	}
	
	/**
	 * A method for creating a new .csv file
	 * @param directoryPath The path where the new File is being saved.
	 * @return Nothing.
	 * @exception IOException If path does not exist.
	 */
	public static void neuesDokument(String directoryPath) throws IOException {
		Scanner scanner = new Scanner(System.in);
		String spalten="";
		while(true) {
			System.out.println("Wie viele Spalten soll ihr Dokument haben?(1-26)");
			System.out.print("->");
			spalten=scanner.nextLine();
			if (Integer.parseInt(spalten)<=26&&Integer.parseInt(spalten)>=1) {
				break;
			}
			else {
				System.err.println("Zahl nicht zwischen 1-26!");
			}
		}
		String zeilen="";
		while(true) {
			System.out.println("Wie viele Zeilen soll ihr Dokument haben?(1-99)");
			System.out.print("->");
			zeilen=scanner.nextLine();
			if (Integer.parseInt(zeilen)<=99&&Integer.parseInt(zeilen)>=1) {
				break;
			}
			else {
				System.err.println("Zahl nicht zwischen 1-99!");
			}
		}
		
		
		String name="";
		while (true) {
			System.out.println("Wie soll ihr Dokument heißen?");
			System.out.print("->");
			
			name = scanner.nextLine();
			File file = new File(directoryPath, name + ".csv");

			if (file.exists()) {
				System.out.println("\nDie Datei '" + name + ".csv" + "' existiert bereits, wähle einen anderen Namen");

			} else {
				break;
			}
		}
		Spreadsheet spr = new Spreadsheet(Integer.parseInt(zeilen),Integer.parseInt(spalten));
		String filePath=directoryPath+name+".csv";
		
		spr.saveCsv(filePath);
		System.out.println("Die Datei '"+name+".csv' wurde angelegt");
		
		Spreadsheet spr1 = new Spreadsheet(Integer.parseInt(zeilen),Integer.parseInt(spalten));
        spr1.readCsv(filePath,",");
        System.out.println(spr1);
        
        eingabeLoop(spr1,filePath);
		
	}
	
	/**
	 * A method for selecting a .csv file
	 * @param directoryPath The path where a File can be openend from.
	 * @return Nothing.
	 * @exception IOException if BufferedReader can't access a file.
	 */
	public static void dokumentAuswaehlen(String directoryPath,String filePath) throws IOException  {
		File folder = new File(directoryPath);
		
		Scanner scanner = new Scanner(System.in);
		String userInput="";
		
        if (folder.exists() && folder.isDirectory()) {
            File[] files = folder.listFiles((dir, name) -> name.toLowerCase().endsWith(".csv"));
            
            if (files != null) {
            	while(true) {
	                System.out.println("\nWähle eine Datei aus: ");
	                System.out.println("");
	                for (int i = 0; i < files.length; i++) {
	                    System.out.println((i + 1) + ". " + files[i].getName());
	                }
	                
	                System.out.print("->");
	                userInput = scanner.nextLine();
	                
	                if(Integer.parseInt(userInput)>files.length||Integer.parseInt(userInput)<1) {
	                	System.err.println("Datei nicht vorhanden!");
	               	}
	                else {
	                	break;
	                }
                }
                filePath = directoryPath+files[Integer.parseInt(userInput)-1].getName();
                
                //feststellen wie groß die Datei ist(Zeilen/Spalten)
                BufferedReader reader = new BufferedReader(new FileReader(filePath));
                String line;
                int zeilenAnzahl = 0;
                int spaltenAnzahl = 0;

                while ((line = reader.readLine()) != null) {
                    zeilenAnzahl++;
                    String[] spalten = line.split(",",-1); 			//-1 for empty cells
                    spaltenAnzahl = spalten.length;
                }
                reader.close();
                
                //neues objekt mit zeilen/spalten-anzahl anlegen um .readCsv aufzurufen
                Spreadsheet spr1 = new Spreadsheet(zeilenAnzahl,spaltenAnzahl);
                spr1.readCsv(filePath,",");
                System.out.println(spr1);
                
                eingabeLoop(spr1,filePath);
                 
			} else {
				System.out.println("Es wurde noch keine Datei angelegt.");
			}
		} else {
			System.out.println("Ungültiges Verzeichnis oder Verzeichnis existiert nicht.");
			System.out.println("Geben sie hier das Verzeichnis ein in dem sie Arbeiten möchten");
			System.out.print("-> ");
			directoryPath = scanner.nextLine();
		}
	}

	/**
	 * A method for editing a .csv file
	 * @param filePath The path of the File that will be edited
	 * @param spr1 A Spreadsheet object used to access Spreadsheet-methods
	 * @return Nothing.
	 * @exception FileNotFoundException if file does not exist.
	 */
	private static void eingabeLoop(Spreadsheet spr1, String filePath) throws FileNotFoundException {
		
		System.out.println("\n---------------------------------");
		System.out.println("| Beispiel Formel: 'B2=B5*5'    |");
		System.out.println("| 'save' um zu Speichern        |");
		System.out.println("| 'exit' um Programm zu beenden |");
		System.out.println("---------------------------------");
		int flag = 1;
		while (flag == 1) {
			Scanner scanner = new Scanner(System.in);
			System.out.println("\nGeben sie ihre Formel/Befehl ein: ");
			System.out.print("-> ");
			String userInput = scanner.nextLine();
			
				
			if (userInput.toUpperCase().matches("[A-Za-z][1-9][0-9]?="
					+ "((((([A-Za-z][1-9][0-9]?)|([0-9]+))(\\*|\\+|\\-|\\/))*"
					+ "(([A-Za-z][1-9][0-9]?)|([0-9]+)))|"
					+ "((SUMME|PRODUKT|MITTEL|STABW|MIN|MAX)\\(([A-Za-z][1-9][0-9]*\\:[A-Za-z][1-9][0-9]*)\\)))")){
				String[] parts = userInput.split("=");
				
				//prüft ob eingegebene Zelle im spreadsheet existiert
				
				if(spr1.checkIfCellExists(parts[0])) {
					spr1.put(parts[0], "=" + parts[1]);
				}
				System.out.println(spr1);
				
			} else if (userInput.toLowerCase().contains("exit")) {
				System.out.println("Programm wurde beendet!");
				flag = 0;
			} else if (userInput.toLowerCase().contains("save")) {
				spr1.saveCsv(filePath);
				
				File file = new File(filePath);
		        String filename = file.getName();
		        
				System.out.println("'"+filename+"' wurde erfolgreich gespeichert!");
			} else {
				System.err.println("Formel ist nicht valide!");
			}
		}
		
	}
    
	
}