package de.hs_mannheim.informatik.spreadsheet;

import static org.junit.Assert.assertEquals;

import org.junit.jupiter.api.Test;

class Tests {
	Spreadsheet spr2=new Spreadsheet(10,10);
	
	//Grundrechenarten
	@Test
	void testAddition() {
		
		assertEquals(spr2.calculate("=1+1"),2);
	}
	
	@Test
    void testSubtraction() {
        assertEquals(spr2.calculate("=5-3"), 2);
    }

    @Test
    void testMultiplication() {
        assertEquals(spr2.calculate("=2*3"), 6);
    }

    @Test
    void testDivision() {
        assertEquals(spr2.calculate("=10/2"), 5);
    }
	
    
    
    //Komplexere Methoden
    @Test
    void testSum() {
    	spr2.put("A1", "1");
    	spr2.put("A2", "2");
    	spr2.put("A3", "3");
        assertEquals(spr2.sum("A1","A3"), 6);
    }
    
    @Test
    void testProduct() {
    	spr2.put("A1", "1");
    	spr2.put("A2", "2");
    	spr2.put("A3", "3");
        assertEquals(spr2.pro("A1","A3"), 6);
    }
    
    @Test
    void testMedian() {
    	spr2.put("A1", "1");
    	spr2.put("A2", "2");
    	spr2.put("A3", "3");
        assertEquals(spr2.mit("A1","A3"), 2);
    }
	
	@Test
    void testStandardDeviation() {
    	spr2.put("A1", "1");
    	spr2.put("A2", "2");
    	spr2.put("A3", "3");
    	assertEquals(spr2.statbw("A1","A3"),0.8, 0.1);
    }
	
	@Test
    void testMin() {
    	spr2.put("A1", "1");
    	spr2.put("A2", "2");
    	spr2.put("A3", "3");
    	assertEquals(spr2.min("A1","A3"),1);
    }
	
	@Test
    void testMax() {
    	spr2.put("A1", "1");
    	spr2.put("A2", "2");
    	spr2.put("A3", "3");
    	assertEquals(spr2.max("A1","A3"),3);
    }
	
    

}
